;________________________________________________________________________
;
;                                B C D . A S M
;________________________________________________________________________
;
; BCD Routines for R918_PIC by Max IK3SVW - July 2001
; Taken from u2k package by Byon Garrabrant, N6BG
;________________________________________________________________________

bin2pack			; Take the binary data, pack it into 2 bytes
				; Steve Dimse 2/99
				; fsr loaded with lsb to be converted before call
	movf	fsr,w		; save the address of the data
	movwf	hex1
	movf	indf,w		; load data into input registers of bin2bcd
	movwf	lsb2
	incf	fsr,f
	movf	indf,w
	movwf	msb2
	call	bin2bcd		; convert the data
	movf	hex1,w		; restore the address
	movwf	fsr
	swapf	ten,w
	addwf	one,w
	movwf	indf
	incf	fsr,f
	swapf	onek,w
	addwf	hund,w
	movwf	indf
	return

bin2byte			; convert value pointed to by FSR into 2 digit BCD
	movf	indf,w
	clrf	indf
byteLoop
	incf	indf,f
	addlw	.246
	skpnc
	goto byteLoop
	addlw	.10
	decf	indf,f
	swapf	indf,f
	addwf	indf,f
	return

; binary to BCD routine from "Pic'n Up The Pace"
; by David Benson
;
	cblock
		index
		dig_ctr
		lsb1
		msb1
		lsb2
		msb2
		tenk
		onek
		hund
		ten
		one
	endc

indf	equ	0
status	equ	3
fsr	equ	4

c	equ	0
z	equ	2

bin2bcd
	clrf	tenk
	clrf	onek
	clrf	hund
	clrf	ten
	clrf	one
	clrf	index
	clrf	dig_ctr
subtr	movf	index,w
	call	tbl_lo
	movwf	lsb1
	movf	index,w
	call	tbl_hi
	movwf	msb1
	call	dblsub
	btfss	msb2,7
	goto	incdig
	movlw	tenk
	movwf	fsr
	movf	index,w
	addwf	fsr,f
	movf	dig_ctr,w
	movwf	indf
	movf	index,w
	call	tbl_lo
	movwf	lsb1
	movf	index,w
	call	tbl_hi
	movwf	msb1
	call 	dblplus
	movf	index,w
	sublw	3
	btfsc	status,z
	goto	finish
	incf	index,f
	clrf	dig_ctr
	goto	subtr

incdig	incf	dig_ctr,f
	goto	subtr

finish	movf	lsb2,w
	movwf	one
	return
	
dblsub	movf	lsb1,w
	subwf	lsb2,f
	btfss	status,c
	decf	msb2,f
	movf	msb1,w
	subwf	msb2,f
	return

dblplus	movf	lsb1,w
	addwf	lsb2,f
	btfsc	status,c
	incf	msb2,f
	movf	msb1,w
	addwf	msb2,f
	return